"""
Copyright (c) 2009, Joel Reardon
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
    * Neither the name of the University of Waterloo nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

import socket
import re

def recvall(sock):
	reply = ''
	while True:
		l = len(reply)
		reply += sock.recv(4096)
		if (l == len(reply)):
			break
		l = len(reply)
	return reply	



print "Type HELP for help"
port = 9999
while True:
	sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
	cmd = raw_input("> ")
	if cmd == '':
		break
	if cmd == "HELP":
		print """Here are the commands:
DUMP <filename>              : Writes collected data to filename, 
                             : clears memory.
						 
LIST <ALL|OBSERVER|VARIABLE> : Lists monitored items. Either all,
                             : or either observers or variables.
									  
SETA <family>                : Sets the observation state for all
     <state 1=on, 0=off>     : observees in the same family. The
     <quota>                 : state of 1 is on, 0 is off. If 
     <interval seconds>      : quota is more than zero, then it 
     <interval microseconds> : automatically set the variable off
                             : when quota observations are made.
                             : If the interval is more than zero
                             : then observations will be done
                             : both when forced in code, and 
                             : each time an interval of
                             : wall-clock time expires.
        
SETO <pointer>               : Sets the observation state for a
     <state 1=on, 0=off>     : single observee whose memory
     <quota>                 : address is pointer. See LIST to
     <interval seconds>      : get memory addresses for 
     <interval microseconds> : observees. See SETA for the
                             : description of the other 
                             : parameters.
			 
FLIB <path/to/library>       : Sets a new function library.
                             : Relative paths must include './'.
									
BEGIN <filename>             : Begins an experiment. Enabled
                             : observees will now start reporting
                             : their data, which are outputted to
                             : filename.
									
END                          : Terminates the collection of data.
		
		"""
	try:
		sock.connect(('localhost',port))
	except:
		print "Could not connect to localhost:", port
		sys.exit()

	print sock.sendall(cmd)
	reply = recvall(sock)
	print reply
	sock.close()



